version: '3'

volumes:
  doxilog_local_postgres_data: {}
  doxilog_local_postgres_data_backups: {}

services:
  django: &django
    build:
      context: .
      dockerfile: ./compose/local/django/Dockerfile
    image: doxilog_local_django
    container_name: doxilog_local_django
    depends_on:
      - postgres
      - redis
    volumes:
      - .:/app:z
    env_file:
      - ./.envs/.local/.django
      - ./.envs/.local/.postgres
    ports:
      - '8000:8000'
    command: /start

  postgres:
    build:
      context: .
      dockerfile: ./compose/production/postgres/Dockerfile
    image: doxilog_production_postgres
    container_name: doxilog_local_postgres
    volumes:
      - doxilog_local_postgres_data:/var/lib/postgresql/data
      - doxilog_local_postgres_data_backups:/backups
    env_file:
      - ./.envs/.local/.postgres

  docs:
    image: doxilog_local_docs
    container_name: doxilog_local_docs
    build:
      context: .
      dockerfile: ./compose/local/docs/Dockerfile
    env_file:
      - ./.envs/.local/.django
    volumes:
      - ./docs:/docs:z
      - ./config:/app/config:z
      - ./doxilog:/app/doxilog:z
    ports:
      - '9000:9000'
    command: /start-docs

  redis:
    image: redis:6
    container_name: doxilog_local_redis

  celeryworker:
    <<: *django
    image: doxilog_local_celeryworker
    container_name: doxilog_local_celeryworker
    depends_on:
      - redis
      - postgres
    ports: []
    command: /start-celeryworker

  celerybeat:
    <<: *django
    image: doxilog_local_celerybeat
    container_name: doxilog_local_celerybeat
    depends_on:
      - redis
      - postgres
    ports: []
    command: /start-celerybeat

  flower:
    <<: *django
    image: doxilog_local_flower
    container_name: doxilog_local_flower
    ports:
      - '5555:5555'
    command: /start-flower
